package tg;
//
// Turtle Graphics Library extension for teaching OO concepts
// as a modification of Tatsuya Hagino's Turtle Graphics Library
// Copyright (C) 2000, Hideki Tsuiki, Kyoto University

// Turtle Graphics Library for Information Processing I
// Copyright (C) 1998, Tatsuya Hagino, Keio University
//
// Permission to use, copy, modify, and distribute this software
// for educational purpose only is hereby granted, provided that
// the above copyright notice appear in all copies and that both
// the copyright notice and this permission notice appear in
// supporting documentation.  This software is provided "as is"
// with no warranty.


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.Math;
import java.util.Vector;


/** ȥɽȤΥ饹 */

public class TurtleFrame extends TurtlePanel implements ActionListener, ItemListener { 
  JFrame frame;
  // menu
  JRadioButtonMenuItem[] speedMenu;
  static String[] speedMenuString = {"no kame", "fast", "normal", "slow"};

  /** TurtlePanel width x height 礭Ǻ롣 */
  public TurtleFrame(int width, int height) {
    super(width, height);
    frame = new JFrame("Turtle");
    JMenuBar menubar = new JMenuBar();
    JMenu file = new JMenu("File", true);
    menubar.add(file);
    JMenuItem quit = new JMenuItem("Quit");
    quit.addActionListener(this);
    quit.setActionCommand("quit");
    file.add(quit);

    JMenu speed = new JMenu("Speed", true);
    menubar.add(speed);
    speedMenu = new JRadioButtonMenuItem[speedMenuString.length];
    ButtonGroup bg = new ButtonGroup();
    for (int i = 0; i < speedMenuString.length; i++) {
      speedMenu[i] = new JRadioButtonMenuItem(speedMenuString[i], false);
      speedMenu[i].addItemListener(this);
      speed.add(speedMenu[i]);
      bg.add(speedMenu[i]);
    }
    speedMenu[Turtle.speedNormal].doClick();
    frame.setJMenuBar(menubar);
    Container c = frame.getContentPane();
    c.setLayout(new BoxLayout(c, BoxLayout.Y_AXIS));
    setAlignmentX(JComponent.CENTER_ALIGNMENT);
    c.add(this);
    frame.pack();
    frame.setVisible(true);
    synchronized(mappedLock) {
      if (!mapped) {
	try {
	  mappedLock.wait();
	}
	catch (InterruptedException e) {
	}
      }
    }
  }

  /** TurtleFrame 򡢥ǥեȤ礭(400x400) Ǻ롣 */
  public TurtleFrame() {
    this(400,400);
  }

  // exit
  public void exit() {
    System.exit(0);
  }

  // menu bar event handler
  public void actionPerformed(ActionEvent e) {
    String cmd = e.getActionCommand();
    if (cmd.equals("quit")) System.exit(0);
    else if (cmd.equals("restart")) /*restart()*/;
    else if (cmd.equals("ps")) /*savePostscript()*/; 
  }

  // menu event handler
  public void itemStateChanged(ItemEvent e) {
    JRadioButtonMenuItem s = (JRadioButtonMenuItem)e.getItem();
    for (int i = 0; i < speedMenuString.length; i++) {
      if (s == speedMenu[i]) {
	Turtle.speedAll(i);
	break;
      }
    }
  }
}



